﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

namespace System.Web
{
    public partial class Local: LocalBase
    {
        public class String : Var<string>
        {
            public String(string key, params Sources[] sourceTypes)
                : base(key, sourceTypes) { }
            public String(string key, int? targetTypes, params Sources[] sourceTypes)
                : base(null, key, null, null, null, targetTypes, sourceTypes) { }
            public String(string defaultValue, string key, params Sources[] sourceTypes)
                : base(defaultValue, key, sourceTypes) { }
            public String(string defaultValue, string key, int? targetTypes, params Sources[] sourceTypes)
                : base(defaultValue, key, null, null, null, targetTypes, sourceTypes) { }
            public String(string defaultValue, string key, TimeSpan? cookieLifeTime, TimeSpan? cacheLifeTime, int? targetTypes, params Sources[] sourceTypes)
                : base(defaultValue, key, cookieLifeTime, null, cacheLifeTime, targetTypes, sourceTypes) { }

        }

        public class Boolean : NullableVar<bool>
        {
            public Boolean(string key, params Sources[] sourceTypes)
                : base(false, key, null, null, null, null, sourceTypes) { }
            public Boolean(string key, int? targetTypes, params Sources[] sourceTypes)
                : base(false, key, targetTypes, sourceTypes) { }
            public Boolean(bool defaultValue, string key, params Sources[] sourceTypes)
                : base(defaultValue, key, null, null, null, null, sourceTypes) { }
            public Boolean(bool defaultValue, string key, int? targetTypes, params Sources[] sourceTypes)
                : base(defaultValue, key, null, null, null, targetTypes, sourceTypes) { }
            public Boolean(bool defaultValue, string key, TimeSpan? cookieLifeTime, TimeSpan? cacheLifeTime, int? targetTypes, params Sources[] sourceTypes)
                : base(defaultValue, key, cookieLifeTime, null, cacheLifeTime, targetTypes, sourceTypes) { }
        }

        public class Integer : Var<int>
        {
            public Integer(string key, params Sources[] sourceTypes)
                : base(key, sourceTypes) { }
            public Integer(string key, int? targetTypes, params Sources[] sourceTypes)
                : base(key, targetTypes, sourceTypes) { }
            public Integer(int defaultValue, string key, params Sources[] sourceTypes)
                : base(defaultValue, key, null, null, null, null, sourceTypes) { }
            public Integer(int defaultValue, string key, int? targetTypes, params Sources[] sourceTypes)
                : base(defaultValue, key, null, null, null, targetTypes, sourceTypes) { }
            public Integer(int defaultValue, string key, TimeSpan? cookieLifeTime, TimeSpan? cacheLifeTime, int? targetTypes, params Sources[] sourceTypes)
                : base(defaultValue, key, cookieLifeTime, null, cacheLifeTime, targetTypes, sourceTypes) { }
        }

        public class Double : Var<double>
        {
            public Double(string key, params Sources[] sourceTypes)
                : base(key, sourceTypes) { }
            public Double(string key, int? targetTypes, params Sources[] sourceTypes)
                : base(key, targetTypes, sourceTypes) { }
            public Double(double defaultValue, string key, params Sources[] sourceTypes)
                : base(defaultValue, key, null, null, null, null, sourceTypes) { }
            public Double(double defaultValue, string key, int? targetTypes, params Sources[] sourceTypes)
                : base(defaultValue, key, null, null, null, targetTypes, sourceTypes) { }
            public Double(double defaultValue, string key, TimeSpan? cookieLifeTime, TimeSpan? cacheLifeTime, int? targetTypes, params Sources[] sourceTypes)
                : base(defaultValue, key, cookieLifeTime, null, cacheLifeTime, targetTypes, sourceTypes) { }
        }
    }
}